<template>
    <div class="column q-gutter-y-lg" style="min-width: 300px">
        <div class="text-h5 text-weight-light">
            Add Rule
        </div>
        <div v-if="Options.length > 0">
            <q-select filled label="Rules" :options="Options"
                      option-label="name"
                      map-options
                      :hint="rule.description"
                      v-model="rule">
            </q-select>
        </div>
        <div v-else>
            <div class="text-subtitle1">There are no rules left to add. <br>
                <router-link to="/rule/create/simple">Create more</router-link>
            </div>
        </div>
        <div class="row justify-between">
            <q-btn outline label="back" @click="$emit('back')"/>
            <q-btn label="Add" color='primary' @click="Add" :loading="loading" :disable="rule.id === ''"/>
        </div>
    </div>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {ActiveRuleResponse} from "src/classLibrary/APIModels/core/activeRuleResponse";
import {RulePrincipalResponse} from "src/classLibrary/APIModels/core/rulePrincipalResponse";


@Component
export default class AddRuleDialog extends Vue {
    @Prop() registered!: ActiveRuleResponse[];

    routeParams = {
        floorId: ''
    }

    allRules: RulePrincipalResponse[] = [];
    loading = false;

    rule: RulePrincipalResponse = new RulePrincipalResponse('', '', '', '', '', [])

    get Options(): RulePrincipalResponse[] {
        return this.allRules.Without(this.registered.Map(x => x.rule), true);
    }

    async mounted() {
        const pid = this.PersistentStore.StoreValue.project;
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<RulePrincipalResponse[]>(`Rule?projectId=${pid}`, null, token);
        if (r.isErr()) {

            this.$q.notify({
                icon: 'warning',
                color: 'negative',
                message: 'failed to obtain list of existing rules'
            })
            return;
        }
        this.allRules = r.unwrap();
    }


    async Add() {
        this.loading = true;
        const pid = this.PersistentStore.StoreValue.project;
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.QPost(`ActiveRule/${pid}?floorId=${this.routeParams.floorId}&ruleId=${this.rule.id}`
            , null, token)
        if (r.isSome()) {
            this.$q.notify({
                icon: 'warning',
                color: 'negative',
                message: 'Failed to add to floor',
            })
        }
        this.loading = false;
        this.$emit('submit', this.rule)

    }


}
</script>
